//////////////////////////////////////////////////////////////////////////////////
// Engineer: Bechtsoudis Anestis
// 
// Module Name:    Mod M Counter
// Project Name:   PS2 Interface
// Target Devices: Spartan 3AN
// Tool versions:  ISE 10.1
// Description:    Counter to count from 0 to m-1
//
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

module mod_m_counter
  #(
    parameter N=4,  //number of bits in counter
              M=10  //mod-m
   )
   (
    input wire clk, reset,
    output wire max_tick,
    output wire [N-1:0] q
   );
   
   //signal decleration
   reg [N-1:0] r_reg;
   wire [N-1:0] r_next;
   
   //body
   //register
   always @(posedge clk, posedge reset)
     if(reset)
       r_reg<=0;
     else
       r_reg<=r_next;
   
   //next-state logic
   assign r_next=(r_reg==(M-1))?0:r_reg+1;
   
   //output logic
   assign q=r_reg;
   assign max_tick=(r_reg==(M-1))?1'b1:1'b0;
endmodule  