//////////////////////////////////////////////////////////////////////////////////
// Engineer: Bechtsoudis Anestis
// 
// Module Name:    Test UART
// Project Name:   UART
// Target Devices: Spartan 3AN
// Tool versions:  ISE 10.1
// Description:    Circuit to verify UART interface
//
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

module uart_test
  (
   input wire clk, reset,
   input wire rx,
   input wire btn,
   output wire tx,
   output wire [7:0] led
  );
  
  //signal declaration
  wire tx_full, rx_empty, btn_tick;
  wire [7:0] rec_data, rec_data1;
  
  //body
  //instantiate uart
  uart uart_unit
    (.clk(clk), .reset(reset), .rd_uart(btn_tick), .wr_uart(btn_tick), .rx(rx),
     .w_data(rec_data1), .tx_full(tx_full), .rx_empty(rx_empty), .r_data(rec_data), .tx(tx));
     
  //instantiate debounce ciruit
  debounce btn_db_unit
    (.clk(clk), .reset(reset), .sw(btn), .db_level(), .db_tick(btn_tick));
    
  //incremented data loops back
  assign rec_data1=rec_data+1;
  
  //LED display
  assign led = rec_data;
endmodule